define([
    "dojo/parser",
    "dojo/_base/window",
    "dojo/on",
    "dojo/_base/lang",
    "dojo/json",
    "dojo/request",
    "dojo/dom",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/_base/declare",
    "dijit/_WidgetBase",
    "dijit/_OnDijitClickMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Form",
    "dijit/form/ValidationTextBox",
    "dijit/form/TextBox",
    "dijit/form/Button",
    "dijit/TooltipDialog",
    "dijit/popup",
    "dijit/layout/LinkPane",
    "dgrid/Grid",
    "dgrid/extensions/DijitRegistry",
    "dojo/text!./templates/AutosomalFilesPane.html",
    "dojo/_base/array",
    "dgrid/OnDemandGrid",
    "dgrid/editor",
    "dijit/InlineEditBox",
    "dgrid/Selection",
    "dgrid/CellSelection",
    "dgrid/Keyboard",
    "dojo/domReady!"
], function(parser, window, on, lang, json, request, dom, domStyle, domConstruct, declare, _WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin, Form, ValidationTextBox, TextBox, Button, TooltipDialog, popup, LinkPane, Grid, DijitRegistry, template, arrayUtil, OnDemandGrid, editor, InlineEditBox, Selection, CellSelection, Keyboard, domReady) {
 
     return declare([_WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin], {
        templateString: template,
        widgetName: "AutosomalFilesPane",

        getWidgetContent: function(arg)
        {
          this.anchor.innerHTML = "Collecting info on Autosomal Files...";
          request("services/get" + this.widgetName + "Content.php?arg=" + arg).then(lang.hitch(this, this.showContent));
        },
        showContent: function(response)
        {
          var r = json.parse(response);
          if(r['reauth'] == 1) window.global.app.widgets.LogoutPane.onButtonClick();
          this.anchor.innerHTML = r['text']; 
        },

        paneExposed: function()
        {
          console.log(this.widgetName + " exposed", this);
          this.getWidgetContent();
        },

        postCreate: function()
        {
          console.log(this.widgetName + " postCreate:", this);
        },
        startup: function()
        {
          window.global.app.widgets[this.widgetName] = this;
        }
       
    });
});
