define([
    "dojo/parser",
    "dojo/_base/window",
    "dojo/on",
    "dojo/_base/lang",
    "dojo/json",
    "dojo/request",
    "dojo/dom",
    "dojo/dom-style",
    "dojo/dom-construct",
    "dojo/_base/declare",
    "dijit/_WidgetBase",
    "dijit/_OnDijitClickMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Form",
    "dijit/form/ValidationTextBox",
    "dijit/form/TextBox",
    "dijit/form/Button",
    "dojo/store/Memory",
    "dijit/form/FilteringSelect",
    "dijit/Dialog",
    "dijit/popup",
    "dijit/layout/LinkPane",
    "dgrid/Grid",
    "dgrid/extensions/DijitRegistry",
    "dojo/text!./templates/BadRecordsPane.html",
    "dojo/_base/array",
    "dgrid/OnDemandGrid",
    "dgrid/editor",
    "dijit/InlineEditBox",
    "dgrid/Selection",
    "dgrid/CellSelection",
    "dgrid/Keyboard",
    "dojo/domReady!"
], function(parser, window, on, lang, json, request, dom, domStyle, domConstruct, declare, _WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin, Form, ValidationTextBox, TextBox, Button, Memory, FilteringSelect, Dialog, popup, LinkPane, Grid, DijitRegistry, template, arrayUtil, OnDemandGrid, editor, InlineEditBox, Selection, CellSelection, Keyboard, domReady) {
 
     return declare([_WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin], {
        templateString: template,
        widgetName: "BadRecordsPane",
        selects: null,
        rotors: null,
        updaters: null,
        predictors: null,
        latestStatus: 0,
        latestGpid: "",

        refreshGrid: function(response)
        {
          this.badrecords_data = [];
          this.badrecords_parsed = json.parse(response);
          if(this.badrecords_parsed['reauth'] == 1)
          {
            window.global.app.widgets.LogoutPane.onButtonClick();
            return;
          }
          console.log(this.badrecords_parsed);
          for(var i=0; i<this.badrecords_parsed.length; i++)
          {
            var e = this.badrecords_parsed[i];
            this.badrecords_data.push(
              {
                b_gpid: e.gpid,
                b_updated: e.lastupdated.substr(0, 10),
                b_bad_yhg: e.yhg
              }
            );
          }
          this.badrecords_grid.refresh(this.badrecords_data);
          this.badrecords_grid.renderArray(this.badrecords_data);
          console.log(this.badrecords_grid);

          /* this.anchor.innerHTML = response; */
        },
        showStrDialog: function(response)
        {
          if(response.length == 0)
          {
            window.global.app.widgets.LogoutPane.onButtonClick();
            return;
          }
          var myDialog = new Dialog({
            title: "STRs for " + this.latestGpid,
            style: "width: 300px"
          });
          myDialog.set("content", response);
          myDialog.show();
        },
        populateFilteringSelectEvent: function(response)
        {
          console.log("populateFilteringSelectEvent:", response, this);
          this.latestStatus = response.status;
        },
        populateFilteringSelectError: function(response)
        {
          console.log("populateFilteringSelectError:", response, this);
          if(this.latestStatus != undefined)
          {
            var myDialog = new Dialog({
              title: "An error has occurred.",
              style: "width: 300px"
            });
            myDialog.set("content", "Error " + this.latestStatus + " has occurred.<br>Please resubmit your request.");
            myDialog.show();
            this.rotors[this.latestGpid].style.visibility = "hidden";
          }
        },
        populateFilteringSelect: function(response)
        {
          if(response.length == 0)
          {
            window.global.app.widgets.LogoutPane.onButtonClick();
            return;
          }
          var data = new Array();
          var r = json.parse(response);
          var gpid = r[0];
          var gpid_yhgs = r[1];
          var yhgs = r[2];
          var targetSelect = this.selects[gpid];
          var first = null;
          for (var key in yhgs)
          {
            if (yhgs.hasOwnProperty(key)) 
            {
              // data.push({name: key, id: key});
              data.push({name: key + " (" + yhgs[key] + ")", id: key});
              if(first == null) first = key + " (" + yhgs[key] + ")";
            }
          }
          var yhgStore = new Memory({ data: data, identifier: 'id' });
          targetSelect.store = yhgStore;

          setTimeout(function() {
            console.log("first:", first);
            targetSelect.set("displayedValue", first);
          },900);
          // targetSelect.set('displayedValue', first + " (491)");
          // targetSelect.setDisplayedValue(first);

          console.log("populateFilteringSelect targetSelect:", targetSelect);
          console.log("populateFilteringSelect data:", data);
          console.log("populateFilteringSelect this:", this);
          this.rotors[gpid].style.visibility = "hidden";
          for (var key in this.predictors)
          {
            if (this.predictors.hasOwnProperty(key))
            {
              this.predictors[key].set("disabled", false);
            }
          }
        },
        databaseUpdateComplete: function(response)
        {
          var response1 = json.parse(response);
          if(response1['reauth'] == 1) 
          {
            window.global.app.widgets.LogoutPane.onButtonClick();
            return;
          }
          var gpid = response1.gpid;
          console.log("remove GPID:", gpid);
          var pos = -1;
          for(var i=0; i<this.badrecords_data.length; i++)
          {
            if(this.badrecords_data[i].b_gpid == gpid)
            {
              pos = i;
              console.log("found at pos." + pos);
              break;
            }
          }
          if(pos >= 0)
          {
            console.log("splicing: length before:", this.badrecords_data.length);
            this.badrecords_data.splice(pos, 1);
            console.log("splicing: length after:", this.badrecords_data.length);
          }
          this.badrecords_grid.refresh(this.badrecords_data);
          this.badrecords_grid.renderArray(this.badrecords_data);
        },
        updateButtonPressed: function(e)
        {
          console.log("updateButtonPressed", e);
          var gpid = e.b_gpid;
          var selector = this.selects[gpid];
          request("services/updateYhg.php?gpid=" + gpid + "&yhg=" + selector.displayedValue).then(lang.hitch(self, this.databaseUpdateComplete));
        },

        strsButtonPressed: function(e)
        {
          console.log("strsButtonPressed", e);
          var gpid = e.b_gpid;
          self = window.global.app.widgets.BadRecordsPane;
          self.latestGpid = gpid;
          request("services/showStrs.php?gpid=" + gpid).then(lang.hitch(self, self.showStrDialog));
        },

        predictButtonPressed: function(e)
        {
          console.log("predictButtonPressed", e);
          var gpid = e.b_gpid;
          self = window.global.app.widgets.BadRecordsPane;
          self.latestGpid = gpid;
          var req = request("services/similar.php?gpid=" + gpid);
          req.then(lang.hitch(self, self.populateFilteringSelect), lang.hitch(self, self.populateFilteringSelectError), lang.hitch(self, self.populateFilteringSelectEvent));
          self.rotors[gpid].style.visibility = "visible";
          for (var key in self.predictors)
          {
            if (self.predictors.hasOwnProperty(key))
            {
              self.predictors[key].set("disabled", true);
            }
          }
        },

        haplogroupChosen: function(e, e1, e2, e3, e4)
        {
          var gpid = e.b_gpid;
          var new_yhg = e2.value; 
          console.log("haplogroupChosen this", this);
          console.log("badrecords_grid:", this.badrecords_grid, gpid, new_yhg);
/*
          this.badrecords_grid.refresh(this.badrecords_data);
          this.badrecords_grid.renderArray(this.badrecords_data);
*/
          this.updaters[gpid].set("disabled", false);

        },

        createGrid: function(response)
        {
          var actionRenderStrs = function (object, data, cell) {
            self = this;
            var btnStrs = new Button({
                rowId : object.id,
                label: "STRs",
                onClick: function () {
                    self.strsButtonPressed(object, cell, this, self);
                }
            }, cell.appendChild(document.createElement("div")));
            btnStrs._destroyOnRemove = true;
            return btnStrs;
          };

          var actionRenderPredict = function (object, data, cell) {
            self = this;
            var btnPredict = new Button({
                rowId : object.id,
                label: "Predict",
                onClick: function () {
                    self.predictButtonPressed(object, cell, this, self);
                }
            }, cell.appendChild(document.createElement("div")));
            btnPredict._destroyOnRemove = true;
            this.predictors[object.b_gpid] = btnPredict;
            return btnPredict;
          };

          var actionRenderUpdate = function (object, data, cell) {
            self = this;
            var btnUpdate = new Button({
                rowId : object.id,
                label: "Update",
                onClick: function () {
                    self.updateButtonPressed(object, cell, this, self);
                }
            }, cell.appendChild(document.createElement("div")));
            btnUpdate._destroyOnRemove = true;
            btnUpdate.set("disabled", true);
            this.updaters[object.b_gpid] = btnUpdate;
            return btnUpdate;
          };

          var actionRenderProgress = function (object, data, cell) {
            self = this;
            var img = document.createElement('img');
            img.src = "app/images/rotating_arrow.gif";
         
            var newchild = cell.appendChild(img);
            this.rotors[object.b_gpid] = img;
            img.style.visibility = "hidden";
            return img;
          };

          var actionRenderChooseHaplogroup = function (object, data, cell) {
            self = this;

            var yhgStore = new Memory({ data: [] });

            var selChooseHaplogroup = new FilteringSelect({
                rowId : object.id,
                store: yhgStore,
                searchAttr: "name",
                onChange: function () {
                    self.haplogroupChosen(object, cell, this, self);
                }
            }, cell.appendChild(document.createElement("div")));
            selChooseHaplogroup._destroyOnRemove = true;
            this.selects[object.b_gpid] = selChooseHaplogroup;
            selChooseHaplogroup.messages.invalidMessage = 'Warning: Haplogroup not from list.';
            selChooseHaplogroup.messages.missingMessage = 'Haplogroup is required.';
            return selChooseHaplogroup;
          };

          var columns =
          [
            { field: "b_gpid", label: "GPID", id: "col1"},
            { field: "b_updated", label: "Updated", id: "col2"},
            { field: "b_bad_yhg", label: "Current YHG", id: "col3"},
            { field: "b_strs", label: "", renderCell: lang.hitch(this, actionRenderStrs), id: "col3a"},
            { field: "b_predict", label: "", renderCell: lang.hitch(this, actionRenderPredict), id: "col4"},
            { field: "b_sim_gpids", label: "Likely YHGs", renderCell: lang.hitch(this, actionRenderChooseHaplogroup), id: "col5"},
            { field: "b_progress", label: "", renderCell: lang.hitch(this, actionRenderProgress), id: "col6"},
            { field: "b_update", label: "", renderCell: lang.hitch(this, actionRenderUpdate), id: "col7"}
          ];

          var CellSelectionGrid = declare([OnDemandGrid, CellSelection, Keyboard]);
          this.badrecords_grid = new CellSelectionGrid({columns: columns, selectionMode: "single", width: "600px"}, this.badrecords);
          this.selects = new Object();
          this.rotors = new Object();
          this.updaters = new Object();
          this.predictors = new Object();
          domConstruct.place("<div data-dojo-attach-point='badrecords'></div>", this.anchor_b, "after");
        },


        paneExposed: function()
        {
          console.log(this.widgetName + " exposed", this);
          request("services/get" + this.widgetName + "Content.php?arg=" + "arg").then(lang.hitch(this, this.refreshGrid));
        },

        postCreate: function()
        {
          console.log(this.widgetName + " postCreate:", this);
        },
        startup: function()
        {
          window.global.app.widgets[this.widgetName] = this;
          this.createGrid();
        }
       
    });
});
