define([
  "dojo/parser",
  "dojo/_base/window",
  "dojo/on",
  "dojo/_base/lang",
  "dojo/json",
  "dojo/request",
  "dojo/dom",
  "dojo/dom-style",
  "dojo/dom-construct",
  "dojo/_base/declare",
  "dijit/_WidgetBase",
  "dijit/_OnDijitClickMixin",
  "dijit/_TemplatedMixin",
  "dijit/_WidgetsInTemplateMixin",
  "dijit/form/Form",
  "dijit/form/Button",
  "dgrid/extensions/DijitRegistry",
  "dojo/text!./templates/DataPushPane.html",
  "dojo/_base/array",
  "dojo/domReady!"
], function(parser, window, on, lang, json, request, dom, domStyle, domConstruct, declare, _WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin, Form, Button, DijitRegistry, template, arrayUtil, domReady) {
 
  return declare([_WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin], {
    templateString: template,
    widgetName: "DataPushPane",

    showContentEvent: function(evt)
    {
      console.log("showContentEvent:", evt, this);
    },

    showContentError: function()
    {
      console.log("showContentError:", this);
    },

    showContent: function(response)
    {
      this.anchor.innerHTML = response;
    },

    paneExposed: function()
    {
      console.log(this.widgetName + " exposed", this);
      request("services/get" + this.widgetName + "Content.php").then(lang.hitch(this, this.showContent), this.showContentError, this.showContentEvent);
      this.copyVsamples.onClick = lang.hitch(this, this.copyVsamplesFunction);
    },

    showResponse: function(response)
    {
      this.copyVsamples.set('disabled', false);
      this.copyVsamples_arrow.style.visibility = "hidden";
      var r = json.parse(response);
      if(r['reauth'] == 1) window.global.app.widgets.LogoutPane.onButtonClick();
    },

    copyVsamplesFunction: function()
    {
      this.copyVsamples.set('disabled', true);
      this.copyVsamples_arrow.style.visibility = "visible";
      request("services/copyVsamples.php").then(lang.hitch(this, this.showResponse));
    },

    startup: function()
    {
      window.global.app.widgets[this.widgetName] = this;
    }
  });
});
