define([
    "dojo/parser",
    "dojo/_base/window",
    "dojo/on",
    "dojo/_base/lang",
    "dojo/json",
    "dojo/request",
    "dojo/dom",
    "dojo/dom-style",
    "dojo/_base/declare",
    "dijit/_WidgetBase",
    "dijit/_OnDijitClickMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Form",
    "dijit/form/ValidationTextBox",
    "dijit/form/TextBox",
    "dijit/form/Button",
    "dijit/TooltipDialog",
    "dijit/popup",
    "dijit/layout/LinkPane",
    "dojo/text!./templates/LoginPane.html",
    "dojo/domReady!"
], function(parser, window, on, lang, json, request, dom, domStyle,  declare, _WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin, Form, ValidationTextBox, TextBox, Button, TooltipDialog, popup, LinkPane, template) {
 
     request("services/invalidateSession.php");
     return declare([_WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin], {
        templateString: template,

        loginFinished: function(data) // Login finished but not necessarily successfully
        {
          var errmsg_node = dom.byId("errmsg");
          this.loginButton.set('disabled', false);
          this.Username.set('value','');
          this.Password.set('value','');
          domStyle.set("rot_arrow", "display", "none");
          console.log("loginFinished:", data);
          var response = json.parse(data);
          if(response.status == "false")
          {
            errmsg_node.innerHTML = "Login failed.";
          }
          else
          {
            // Login succeeded.
            errmsg_node.innerHTML = "";
            window.global.app.widgets.Dispatcher.username = this.username;
            window.global.app.widgets.Dispatcher.role = response.role;
            window.global.app.widgets.Dispatcher.humanname = response.humanname;
            window.global.app.widgets.Dispatcher.showLogoutPane();
            window.global.app.widgets.Dispatcher.enableTabs();
            console.log("login successful; role:", response.role, response.humanname);
          }

        },

        postCreate: function()
        {
          console.log("LoginPane postCreate:", this);
        },
        onButtonClick: function(x)
        {
          var username = this.Username.value;
          var password = this.Password.value;
          this.username = username;
          domStyle.set("rot_arrow", "display", "inline");
          this.loginButton.set('disabled', true);

          request("services/createSession.php?username=" + username + "&password=" + password).then(lang.hitch(this, this.loginFinished));
          //  request("services/invalidateSession.php");
        },
        startup: function()
        {
          console.log("LoginPane startup this:", this);
          window.global.app.widgets.LoginPane = this;
          domStyle.set("rot_arrow", "display", "none");
          this.loginButton.onClick = lang.hitch(this, this.onButtonClick);
        }
       
    });
});
