define([
    "dojo/parser",
    "dojo/_base/window",
    "dojo/on",
    "dojo/_base/lang",
    "dojo/json",
    "dojo/request",
    "dojo/dom",
    "dojo/dom-style",
    "dojo/_base/declare",
    "dijit/_WidgetBase",
    "dijit/_OnDijitClickMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Form",
    "dijit/form/ValidationTextBox",
    "dijit/form/TextBox",
    "dijit/form/Button",
    "dijit/TooltipDialog",
    "dijit/popup",
    "dijit/layout/LinkPane",
    "dojo/text!./templates/LogoutPane.html",
    "dojo/domReady!"
], function(parser, window, on, lang, json, request, dom, domStyle,  declare, _WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin, Form, ValidationTextBox, TextBox, Button, TooltipDialog, popup, LinkPane, template) {
 
     return declare([_WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin], {
        templateString: template,

        logoutFinished: function(data) // Logout finished
        {
          var errmsg_node = dom.byId("errmsg1");
          console.log("logoutFinished:", data);

          domStyle.set("rot_arrow1", "display", "none");
          
          // Logout succeeded.
          errmsg_node.innerHTML = "";
          window.global.app.widgets.Dispatcher.username = null;
          window.global.app.widgets.Dispatcher.humanname = null;
          window.global.app.widgets.Dispatcher.showLoginPane();
          console.log("logout successful; window:", window);
          this.logoutButton.set('disabled', false);
          window.global.app.widgets.Dispatcher.disableTabs();
        },

        postCreate: function()
        {
          console.log("LogoutPane postCreate:", this);
        },
        onButtonClick: function()
        {
          domStyle.set("rot_arrow1", "display", "inline");
          window.global.app.widgets.LogoutPane.logoutButton.set('disabled', true);
          window.global.app.widgets.GeneralPane.mainTabContainer.selectChild(window.global.app.widgets.GeneralPane.tab0);

          request("services/invalidateSession.php").then(lang.hitch(window.global.app.widgets.LogoutPane, window.global.app.widgets.LogoutPane.logoutFinished));
        },
        startup: function()
        {
          console.log("LogoutPane startup this:", this);
          window.global.app.widgets.LogoutPane = this;
          domStyle.set("rot_arrow1", "display", "none");
          this.logoutButton.onClick = lang.hitch(this, this.onButtonClick);
        }
       
    });
});
