define([
    "dojo/window",
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/_WidgetBase",
    "dojo/dom-class",
    "dojo/request",
    "dijit/layout/TabContainer",
    "dijit/layout/BorderContainer",
    "dijit/layout/ContentPane",
    "app/Dispatcher",
    "app/GeneralPane",
    "app/LoginPane",
    "app/LogoutPane",
    "dojo/domReady!"
], function(DojoWindow, declare, lang, _WidgetBase, DomClass, request, TabContainer, BorderContainer, ContentPane, Dispatcher, GeneralPane, LoginPane, LogoutPane){
    return declare([_WidgetBase], {
      dispatcher: null,
      bc: null,
      cp_top_login: null,
      cp_top_logout: null,
      viewport: null,
      postCreate: function()
      {
        console.log("MainBorderContainer: postCreate:", this);
        
        // setTimeout(lang.hitch(this, this.cont1), 9000);
        this.dispatcher = new Dispatcher();
        // create a BorderContainer as the top widget in the hierarchy
        
        var vs = DojoWindow.getBox();
        this.viewport = {};
        this.viewport.height = vs.h;
        this.viewport.width = vs.w;
        console.log(vs);
        this.bc = new BorderContainer({
          style: "height: " + this.viewport.height + "px; width: " + this.viewport.width + "px;"
        });
        this.bc.design = "headline";
        // create a ContentPane as the top pane in the BorderContainer - it will contain login/logout button and the background image.      
        this.cp_top_login = new LoginPane({
          region: "top",
          style: "height: 50px",
          id: "topPane",
          content: "TOP"
        });
        this.bc.addChild(this.cp_top_login);
        this.cp_top_logout = new LogoutPane({
          region: "top",
          style: "height: 50px",
          id: "topPane1", 
          content: "TOP"
        });
        
        // create a ContentPane as the left pane in the BorderContainer - it will contain all the tabs.
        var cp_left = new GeneralPane({
            region: "left",
            style: "width: 100%",
            splitter: "true",
            content: "LEFT"
        }); 
        this.bc.addChild(cp_left);
        
        // put the top level widget into the document, and then call startup()
        this.bc.placeAt(document.body);
        this.bc.startup();
        // DomClass.add("topPane", "topImage");
        this.dispatcher.mainContainer = this.bc;
        this.dispatcher.loginContainer = this.cp_top_login;
        this.dispatcher.logoutContainer = this.cp_top_logout;
        this.dispatcher.viewport = this.viewport;
      }
    });
    
});
