define([
    "dojo/parser",
    "dojo/dom-construct",
    "dojo/_base/window",
    "dojo/_base/lang",
    "dojo/on",
    "dojo/json",
    "dojo/request",
    "dojo/dom",
    "dojo/dom-style",
    "dojo/_base/declare",
    "dijit/_WidgetBase",
    "dijit/_OnDijitClickMixin",
    "dijit/_TemplatedMixin",
    "dijit/_WidgetsInTemplateMixin",
    "dijit/form/Form",
    "dijit/form/ValidationTextBox",
    "dijit/form/SimpleTextarea",
    "dijit/form/Button",
    "dijit/form/Select",
    "dojox/gfx",
    "dgrid/Grid",
    "dijit/layout/ContentPane",
    "dijit/layout/BorderContainer",
    "dgrid/extensions/DijitRegistry",
    "dojo/text!./templates/Snps.html",
    "dojo/_base/array",
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "dgrid/CellSelection",
    "dgrid/Keyboard",
    "dojo/domReady!"
], function(parser, domConstruct, window, lang, on, json, request, dom, domStyle,  declare, _WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin, Form, ValidationTextBox, SimpleTextarea, Button, Select, gfx, Grid, ContentPane, BorderContainer, DijitRegistry, template, arrayUtil, OnDemandGrid, Selection, CellSelection, Keyboard, domReady) {

     return declare([_WidgetBase, _OnDijitClickMixin, _TemplatedMixin, _WidgetsInTemplateMixin], {
        templateString: template,
        gpid: null,
        diagramSize: 610,
        data: null,

        postCreate: function()
        {
          console.log("postCreate:", this);
        },
        onButtonClick: function(arg)
        {
          console.log("button:", this);
          console.log("arg:", arg);
        },
        startup: function()
        {
          console.log("Strs startup(): this:", this);
          setTimeout(lang.hitch(this, this.populateTable), 2000);
        },
        populateTable: function()
        {
          var columns = {
            curent: "Current",
            backup: "Backup"
          };
          var data = [];
          var current = "";
          var backup = ""
          for(var i=0; i<this.snps.length; i++)
          {
            if(this.snps[i].c_gpid == this.gpid)
            {
              if(this.snps[i].c_version == "current") current = this.snps[i]["c_haplosnps_details"];
              if(this.snps[i].c_version == "backup") backup = this.snps[i]["c_haplosnps_details"];
            }
          }
          current += "ZZZZ\n";
          backup += "ZZZZ\n";
          current = current.split("\n");
          backup = backup.split("\n");
          var i_current = 0;
          var i_backup = 0;
          for(var i=0; ; i++)
          {
            if(i_current >= current.length && i_backup == backup.length) break;
            if(current[i_current] == backup[i_backup])
            {
              data[i] = {current: current[i_current], backup: backup[i_backup]};
              i_current++;
              i_backup++;
            }
            else
            {
              if(current[i_current] < backup[i_backup])
              {
                data[i] = {current: current[i_current], backup: ""};
                i_current++;
              }
              else
              {
                data[i] = {current: "", backup: backup[i_backup]};
                i_backup++;
              }
            }
          }
 
          console.log("data:", data);
          this.snps_grid = new Grid({columns: columns, data: data}, this.snps_ap2);
          // this.snps_grid.refresh(data);
          // this.snps_grid.renderArray(data);
          console.log("this.snps_grid:", this.snps_grid);
          console.log("this.snps_ap2:", this.snps_ap2);
          // setTimeout(lang.hitch(this, this.layoutContainers), 500);
        } 
        
    }); 
});     
